// Generated by CoffeeScript 2.3.2
// socket = io()
// console.log socket
var Calling, ClearCurrenPart, Current, CurrentPart, History, IdleWatcher, KickTime, LastTimePartEnded, Looper, Map, Menu, Player, StartMenu, Track, backsample, decode, hangup, incomingdigit, init, isLooper, load, loadedBuffer, newBuffer, now, numbers, pickup, play, signalsample, switchTo, urlExists, watchIdle;

Player = {};

CurrentPart = null;

IdleWatcher = null;

Current = "";

LastTimePartEnded = -1;

Calling = false;

Looper = false;

KickTime = 60 * 1000;

StartMenu = "_";

Map = {};

History = null;

numbers = [];

signalsample = new Tone.Buffer("./samples/_signal.wav");

backsample = new Tone.Buffer("./samples/vissza.wav");

loadedBuffer = function() {
  return $("#time").html($("#time").html() + ".");
};

urlExists = function(url) {
  var http;
  http = new XMLHttpRequest();
  http.open('HEAD', url, false);
  http.send();
  return http.status !== 404;
};

newBuffer = function(url) {
  if (urlExists(url)) {
    return new Tone.Buffer(url, loadedBuffer);
  } else {
    return new Tone.Buffer("./samples/_empty.wav");
  }
};

Menu = class Menu {
  constructor(params) {
    this.name = params[0];
    this.parent = params[1];
    this.outputs = params[2];
    this.info = params[3];
    this.getOutput = function(i) {
      if (i < this.outputs.length) {
        return this.outputs[i];
      } else {
        return null;
      }
    };
    this.info_buffer = newBuffer("./samples/" + this.name + "_info.wav");
    this.content_buffer = newBuffer("./samples/" + this.name + ".wav");
  }

  toString() {
    var i, o, outs;
    outs = (function() {
      var j, len, ref, results;
      ref = this.outputs;
      results = [];
      for (i = j = 0, len = ref.length; j < len; i = ++j) {
        o = ref[i];
        results.push(`${i + 1} : ${Map[o].info}`);
      }
      return results;
    }).call(this);
    return this.info + "\n" + outs.join("\n");
  }

};

now = function(time) {
  if (time) {
    return new Date(time).getTime();
  } else {
    return new Date().getTime();
  }
};

ClearCurrenPart = function() {
  Player.stop();
  return CurrentPart.removeAll();
};

// CurrentPart.dispose()
play = function(node, nointro) {
  var addDurations, buffer, ending_time, last, timetable;
  if (node.outputs.length === 0) {
    // DEAD END
    buffer = node.content_buffer;
    // if node.name is "m_kapcsolat" then pickRandom
    CurrentPart = new Tone.Part((function(t, o) {
      if (o.buffer == null) {
        return switchTo(node.parent);
      } else {
        Player.buffer = o.buffer;
        return Player.start();
      }
    }), [
      {
        time: 0,
        buffer: buffer
      },
      {
        time: buffer.duration
      }
    ]);
    return CurrentPart.start();
  } else {
    // CLASSIC
    addDurations = function(_a, _v) {
      return _a + _v.buffer.duration;
    };
    timetable = node.outputs.reduce((function(list, output, i) {
      return list.concat([
        {
          time: list.reduce(addDurations,
        0),
          buffer: Map[output].info_buffer
        },
        {
          time: list.reduce(addDurations,
        0) + Map[output].info_buffer.duration,
          buffer: numbers[i + 1]
        }
      ]);
    }), (nointro ? [] : [
      {
        time: 0,
        buffer: node.content_buffer
      }
    ]));
    if (node.name !== "_") {
      timetable.push({
        time: timetable.reduce(addDurations, 0),
        buffer: backsample
      });
    }
    last = timetable[timetable.length - 1];
    ending_time = last.time + last.buffer.duration;
    CurrentPart = new Tone.Part((function(t, o) {
      if (o.buffer == null) {
        return LastTimePartEnded = now();
      } else {
        Player.buffer = o.buffer;
        return Player.start();
      }
    }), timetable.concat([
      {
        time: ending_time
      }
    ]));
    return CurrentPart.start();
  }
};

watchIdle = function() {
  var et, kt, millisToSec, t;
  millisToSec = function(ms) {
    return Math.abs(Math.floor(0.001 * ms)) + "s";
  };
  t = "";
  if (!Calling && (History != null)) {
    t = "last call was " + millisToSec(now() - now(History.end_time)) + " ago";
  } else if (Calling) {
    et = millisToSec(now() - now(History.start_time));
    t = `call time : ${et}`;
  }
  if (LastTimePartEnded !== -1) {
    kt = millisToSec(now() - (LastTimePartEnded + KickTime));
    t = t + `  --- hanging up in : ${kt}`;
    if (now() > LastTimePartEnded + KickTime) {
      hangup();
    }
  }
  return $("#time").html(t);
};

pickup = function() {
  $("#call").css("display", "none");
  if (!Calling) {
    Player.context.resume();
    console.log("picking up the phone");
    History = {
      start_time: new Date().toString(),
      actions: []
    };
    LastTimePartEnded = -1;
    Calling = true;
    return switchTo(StartMenu, false);
  }
};


// console.log "playing signal"
// Player.buffer = signalsample
// Player.start()
// setTimeout((() -> switchTo(StartMenu, false)), signalsample.duration * 1000)

// else
//   hangup()
//   pickup()
hangup = function() {
  History.end_time = new Date().toString();
  // socket.emit("hang_up", JSON.stringify History )
  // window.clearInterval IdleWatcher
  Player.stop();
  Tone.Transport.seconds = 0;
  if (isLooper(Current)) {
    Looper.stop();
  }
  Current = "";
  Calling = false;
  ClearCurrenPart();
  LastTimePartEnded = -1;
  $("#call").css("display", "block");
  return $("#screen").html("hanged up. \npress CALL to start a new call");
};

incomingdigit = function(d) {
  var action, next;
  if (Calling) {
    LastTimePartEnded = now();
    action = {
      digit: d
    };
    switch (d) {
      case 'C':
        return hangup();
      case '*':
        return switchTo(Map[Current].parent, true);
      case '#':
        break;
      case '0':
      case '1':
      case '2':
      case '3':
      case '4':
      case '5':
      case '6':
      case '7':
      case '8':
      case '9':
        if ((Current != null) && isLooper(Current)) {
          return Looper.toggle(parseInt(d));
        } else {
          next = Map[Current].getOutput((d === 0 ? 0 : d - 1));
          if (next != null) {
            return switchTo(next, false);
          }
        }
    }
  } else {
    if (d === 'A') {
      return pickup();
    }
  }
};

switchTo = function(next, nointro) {
  // console.log "entering #{next}"
  $("#screen").html(Map[next].toString());
  Tone.Transport.seconds = 0;
  LastTimePartEnded = -1;
  if (CurrentPart != null) {
    ClearCurrenPart();
  }
  if ((Current != null) && isLooper(Current)) {
    Looper.stop();
  }
  if (isLooper(next)) {
    LastTimePartEnded = now();
    Looper.init(parseInt(next.substr(6, 1)));
  } else {
    play(Map[next], nointro);
  }
  return Current = next;
};

// History.actions.push next
load = function() {
  var d, i, j, k, len;
  for (i = j = 0; j <= 9; i = ++j) {
    numbers.push(newBuffer(`./samples/${i}.wav`));
  }
  for (k = 0, len = data.length; k < len; k++) {
    d = data[k];
    Map[d[0]] = new Menu(d);
  }
  Looper.load();
  return Tone.Buffer.on("load", init);
};

decode = function() {
  var decoderdigit;
  Decoder.start();
  decoderdigit = function(d) {
    console.log(`decoder got ${d}`);
    return incomingdigit(d);
  };
  return Decoder.callback = decoderdigit;
};

Track = class Track {
  constructor() {
    this.player = new Tone.Player({
      loop: true,
      volume: -6
    }).connect(Tone.Master);
  }

  toggle() {
    return this.player.mute = !this.player.mute;
  }

};

isLooper = function(c) {
  return c.substr(0, 6) === "looper";
};

Looper = {
  tracks: [0, 1, 2, 3, 4, 5, 6, 7, 8].map(function(i) {
    return new Track();
  }),
  songs: [],
  current: 0,
  load: function() {
    var j, results, s, t;
    results = [];
    for (s = j = 1; j <= 2; s = ++j) {
      results.push(this.songs.push((function() {
        var k, results1;
        results1 = [];
        for (t = k = 1; k <= 9; t = ++k) {
          results1.push(newBuffer(`./samples/looper/${s}/${t}.wav`));
        }
        return results1;
      })()));
    }
    return results;
  },
  start: function() {
    return this.tracks.map(function(t) {
      return t.player.start();
    });
  },
  stop: function() {
    return this.tracks.map(function(t) {
      return t.player.stop();
    });
  },
  init: function(s) {
    var i, j, len, ref, t;
    console.log(s);
    ref = this.tracks;
    for (i = j = 0, len = ref.length; j < len; i = ++j) {
      t = ref[i];
      t.player.buffer = this.songs[s - 1][i];
      t.player.mute = i !== 0;
    }
    return Looper.start();
  },
  toggle: function(i) {
    if ((0 < i && i < this.tracks.length + 1)) {
      return this.tracks[i - 1].toggle();
    }
  }
};

init = function() {
  $("#phone").css("display", "flex");
  $("#time", "#screen").html("");
  IdleWatcher = window.setInterval(watchIdle, 1000);
  Player = new Tone.Player().toMaster();
  console.log("loaded");
  Tone.Transport.start();
  $(window).keydown(function(e) {
    console.log(e.key);
    if ("0123456789#*abcd".indexOf(e.key.toLowerCase()) !== -1) {
      return incomingdigit(e.key);
    }
  });
  $(".numpad").click(function(e) {
    encode(e.currentTarget.innerHTML);
    return incomingdigit(e.currentTarget.innerHTML);
  });
  return $("#call").click(pickup);
};


// decode()

// socket.on("pick_up", pickup)
load();

//# sourceMappingURL=client.js.map
